"""
Created on Wed Jan 20 23:54:00 2021

author: N. Abrate.

file: .py

description:
"""
import matplotlib.pyplot as plt
import sys
sys.path.append('Z:\\codici\\')
from pathlib import Path
import numpy as np
import pandas as pd
import serpentTools as st
import rompy.reduction.POD as pod
from rompy.metamodels.NDUQ import ndXGPT, uncformat
from copy import deepcopy
import json

NCG = 6
nref = 1400
f = open('Pu239_%d.json' % nref)
data = json.load(f)

pert = 'MT18'
resp = 'xsFissIfBin'
ref = np.asarray(data['942390'][pert][resp])

data = {}
delta = {}

width = 0.5  # the width of the bars
cases = np.concatenate([np.arange(10, 100, 20), np.arange(200, 1201, 200)])

fig, ax = plt.subplots()
for g in range(0, NCG):
    xmin, xmax = 1, 0
    delta = {}
    for n in cases:
        f = open('Pu239_%d.json' % n)
        data = json.load(f)
        vals = np.asarray(data['942390'][pert][resp])
        delta[str(n)] = abs(ref[g, 0]-vals[g, 0])/ref[g, 0]

    fig, ax = plt.subplots()
    # plot histograms
    ax.bar(list(delta.keys()), list(delta.values()), width, color='goldenrod')

    plt.hlines(ref[g, 1], -width, 1E4, color='r', ls='-.', linewidth=1)
    # Add some text for labels, title and custom x-axis tick labels, etc.
    ax.set_ylabel('rel. truncation err. on uncertainty')
    ax.set_xlabel('# basis functions')
    ax.set_xticks(list(delta.keys()))
    ax.set_yscale('log')
    ax.set_xlim([-width, len(cases)])
    # ax.set_xticklabels(('G1', 'G2', 'G3', 'G4', 'G5', 'G6'))
    # ax.set_yticklabels([])
    ax.set_title('$\Sigma_{f,g=%d}$' % g)
    fig.tight_layout()
    plt.show()

def autolabel(rects, xpos='center'):
    """
    Attach a text label above each bar in *rects*, displaying its height.

    *xpos* indicates which side to place the text w.r.t. the center of
    the bar. It can be one of the following {'center', 'right', 'left'}.
    """

    ha = {'center': 'center', 'right': 'left', 'left': 'right'}
    offset = {'center': 0, 'right': 1, 'left': -1}

    for rect in rects:
        height = rect.get_height()
        ax.annotate('%.3f' % height,
                    xy=(rect.get_x() + rect.get_width()/2, height),
                    xytext=(1, 3),  # use 3 points offset
                    textcoords="offset points",  # in both directions
                    ha=ha[xpos], va='bottom', fontsize=8)

# autolabel(rects1, "center")
# autolabel(rects2, "center")
