"""
Created on Wed Jan 20 23:54:00 2021

author: N. Abrate.

file: .py

description:
"""
import matplotlib.pyplot as plt
import sys
sys.path.append('Z:\\codici\\')
from pathlib import Path
import numpy as np
import pandas as pd
import serpentTools as st
import rompy.reduction.POD as pod
from rompy.metamodels.NDUQ import ndXGPT, uncformat
from copy import deepcopy
import json
from matplotlib import rcParams, ticker, rc
# rcParams['text.usetex'] = True
rcParams['figure.dpi'] = 200
rc('font', **{'family': 'serif', 'serif': ['Computer Modern']})
rc('text', usetex=True)
rcParams.update({'font.size': 15})

NCG = 6

pert = 'mt 102 xs'
resp = 'captIf'

s = {}
n = {}

width = 0.5  # the width of the bars
cases = np.arange(0, 10)

for scale in ['linear', 'log']:
    for g in range(0, NCG):
        delta = {}
        for LG in cases:
            f = open('U238_GPT_unc_%dLG.json' % LG)
            data = json.load(f)
            vals = np.asarray(data[pert][resp])
            n[str(LG)] = vals[g, 0]
            s[str(LG)] = abs(vals[g, 0])*vals[g, 1]*2

        fig, ax = plt.subplots()
        # plot histograms
        ax.bar(list(n.keys()), list(n.values()), width, yerr=list(s.values()),
               color='darkcyan')
        # Add some text for labels, title and custom x-axis tick labels, etc.
        ax.set_ylabel('\% relative uncertainty')
        ax.set_xlabel('number of latent generations')
        ax.set_xticks(list(n.keys()))
        ax.set_yscale(scale)
        ax.set_xlim([-width, len(cases)])
        # ax.set_title('$\Sigma_{c,g=%d}$' % (g+1))
        # plt.ticklabel_format(axis="y", style="sci", scilimits=(0,0))
        fig.tight_layout()
        plt.savefig('LG_GPT_unc_%s_%s_G%d_%s.png' % (pert, resp, (g+1), scale))
        plt.show()

    # keff
    for LG in cases:
        f = open('U238_GPT_unc_%dLG.json' % LG)
        data = json.load(f)
        vals = np.asarray(data[pert]['keff'])
        n[str(LG)] = vals[0, 0]
        s[str(LG)] = abs(vals[0, 0])*vals[0, 1]*2

    fig, ax = plt.subplots()
    # plot histograms
    ax.bar(list(n.keys()), list(n.values()), width, yerr=list(s.values()),
           color='darkcyan')
    # Add some text for labels, title and custom x-axis tick labels, etc.
    ax.set_ylabel('\% relative uncertainty')
    ax.set_xlabel('number of latent generations')
    ax.set_xticks(list(n.keys()))
    ax.set_yscale(scale)
    ax.set_xlim([-width, len(cases)])
    # ax.set_title('$k_{eff}$')
    fig.tight_layout()
    plt.savefig('LG_GPT_unc_%s_%s_keff_%s.png' % (pert, resp, scale))
    plt.show()
