"""
Created on Wed Jan 20 23:54:00 2021

author: N. Abrate.

file: .py

description:
"""
import matplotlib.pyplot as plt
import sys
sys.path.append('Z:\\codici\\')
from pathlib import Path
import numpy as np
import pandas as pd
import serpentTools as st
import rompy.reduction.POD as pod
from rompy.metamodels.NDUQ import ndXGPT, uncformat
from copy import deepcopy
import json
from matplotlib import rcParams
from matplotlib import rc
# rcParams['text.usetex'] = True
rcParams['figure.dpi'] = 200
rc('font', **{'family': 'serif', 'serif': ['Computer Modern']})
rc('text', usetex=True)
rcParams.update({'font.size': 15})

NCG = 6
nref = 1400
f = open('Pu239_%d.json' % nref)
data = json.load(f)

pert = 'MT18'
resp = 'xsFissIfBin'
ref = np.asarray(data['942390'][pert][resp])

data = {}
delta = {}

width = 0.5  # the width of the bars
cases = np.concatenate([np.arange(10, 100, 20), np.arange(200, 1201, 200)])

fig, ax = plt.subplots()
for g in range(0, NCG):
    xmin, xmax = 1, 0
    delta = {}
    for n in cases:
        f = open('Pu239_%d.json' % n)
        data = json.load(f)
        vals = np.asarray(data['942390'][pert][resp])
        delta[str(n)] = abs(ref[g, 0]-vals[g, 0])/ref[g, 0]

    fig, ax = plt.subplots()
    # plot histograms
    ax.bar(list(delta.keys()), list(delta.values()), width, color='goldenrod')

    plt.hlines(ref[g, 1], -width, 1E4, color='r', ls='-.', linewidth=1)
    # Add some text for labels, title and custom x-axis tick labels, etc.
    ax.set_ylabel('rel. truncation err. on uncertainty')
    ax.set_xlabel('number of basis functions')
    ax.set_xticks(list(delta.keys()))
    ax.set_yscale('log')
    ax.set_xlim([-width, len(cases)])
    # ax.set_xticklabels(('G1', 'G2', 'G3', 'G4', 'G5', 'G6'))
    # ax.set_yticklabels([])
    ax.set_title('$\Sigma_{f,g=%d}$' % (g+1))
    fig.tight_layout()
    plt.savefig('POD_truncerr_%s_%s_G%d.png' % (pert, resp, (g+1)))
    plt.show()
